% DPROEQC: one iteration of the Deterministic Parameter
%          Reduced-Order LQG Control EQuation.
%          Control equations of compensator
%          for (P,G,C) and nc=<nx.
%
%          function [st,sh]=dproeqc(p,g,c,v,w,q,r,mc,me,st,sh,pt,ph,ta,ap);
%
%          W.L. De Koning, L.G. Van Willigenburg, 28-11-95.
%

  function [st,sh]=dproeqc(p,g,c,v,w,q,r,mc,me,st,sh,pt,ph,ta,ap);

  [nx1,nx]=size(p);
  tao=ap*(eye(nx)-ta); tap=eye(nx)-tao;
  if min(size(w))~=0;
    wp=w+c*pt*c'; iwp=pinv(wp);
    kh=me+p*pt*c'; p1p=p-kh*iwp*c;
  else;
    p1p=p;
  end;
  if min(size(r))~=0
    rs=r+g'*st*g; irs=pinv(rs);
    lh=g'*st*p+mc'; s2s=lh'*irs*lh;
  else
    s2s=zeros(size(q));
  end;
  psi2=p1p'*sh*p1p+s2s;

  st=p'*st*p-s2s+q+tao'*psi2*tao; st=0.5*(st+st');
  sh=psi2*tap; sh=0.5*(sh+sh');
