% DPROEQE: one iteartion of the Deterministic Parameter
%          Reduced-Order LQG Estimator EQuation.
%          Estimation equations of compensator
%          for (P,G,C) and nc=<nx.
%
%          [pt,ph]=dproeqe(p,g,c,v,w,q,r,st,sh,pt,ph,ta,ap);
%
%          W.L. De Koning, L.G. Van Willigenburg, 28-11-95.

  function [pt,ph]=dproeqe(p,g,c,v,w,q,r,mc,me,st,sh,pt,ph,ta,ap);

  [nx,nx1]=size(p);
  tao=ap*(eye(nx)-ta); tap=eye(nx)-tao;

  if min(size(w))~=0
    wp=w+c*pt*c'; iwp=pinv(wp);
    kh=me+p*pt*c'; s1p=kh*iwp*kh';
  else
    s1p=zeros(size(v));
  end;
  if min(size(r))~=0
    rs=r+g'*st*g; irs=pinv(rs);
    lh=g'*st*p+mc'; p2s=p-g*irs*lh;
  else
    p2s=p;
  end
  psi1=p2s*ph*p2s'+s1p;

  pt=p*pt*p'-s1p+v+tao*psi1*tao'; pt=0.5*(pt+pt);
  ph=psi1*tap'; ph=0.5*(ph+ph');
