function [Pcov,xhat]=kmftu(phio,gamo,vo,Pcov,xhat,uo);
% KMFTU:  Discrete-time Kalman filter time update.
%
%         [Pcov,xhat]=kmftu(phio,gamo,vo,Pcov,xhat,uo);
%
%         Pcov:  Covariance matrix
%         xhat:  Estimate
%         phio:  Discrete-time System state transition matrix
%         gamo:  Discrete-time System control matrix
%         vo:    Discrete-time System state covariance matrix
%         uo:    Previous control
%
%         L.G. Van Willigenburg, W.L. De Koning, 10-01-02.
%
Pcov=phio*Pcov*phio'+vo;
if nargin==6
  xhat=phio*xhat+gamo*uo;
else
  xhat=[];
end;
