% LQGAOB: function adjusts the output matrix
%         c and the corresponding covariance matrix w
%         in case of an asynchronous sampled continuous
%         time system, based on the information with
%         respect to sampling contained in obsmat and
%         the index ind stating the observation instant number.
%
%         [c,w]=lqgaob(obsmat,ind,c,w)
%
%         See also lqgatv.m, lqgady.m, lqgmatv.m, lqgare.m
%
%         L.G. Van Willigenburg, W.L. De Koning, 10-01-02.
%
function [c,w]=lqgaob(obsmat,ind,c,w);

l=obsmat(2,ind);
for i=1:l
  index=obsmat(2+i,ind);
  cnew(i,:)=c(index,:);
  wnew(i,:)=w(index,:);
end;
c=cnew;w=[];
for i=1:l
  index=obsmat(2+i,ind);
  w(:,i)=wnew(:,index);
end;
