function [phi,gam,dis,qi,ri,am,vi,li,ti,xi,gk,c,w,me]=lqgarea(nc,ic,nc1,ic1,phi,gam,dis,qi,ri,am,vi,li,ti,xi,gk,no,io,c,w,me);
% LQGAREA : Function interchanges rows and columns of gam,am,ri,ti according to 
%           the change in order of the control variables specified
%           by the matrix lqgmat and the index ind stating the control
%           instant number.
%
%
%	See also lqgatv.m, lqgaob.m, lqgady.m, lqgmatv.m	
%
[n,m]=size(gam);
if max(size(ti))==0;nti=0;else;nti=1;end;
for i=1:1:m
  index=ic(i); %lqgmat(3+i,ind);
  gamnew(:,i)=gam(:,index);
  amnew(:,i)=am(:,index);
  rinew(:,i)=ri(:,index);
  if nti==1;tinew(1,i)=ti(1,index);end
end;
gam=gamnew;am=amnew;if nti==1;ti=tinew;end;
for i=1:m
  index=ic(i); %lqgmat(3+i,ind);
  ri(i,:)=rinew(index,:);
end;

%
%  Determine new equivalent discrete-time control problem
%  based on the updated controlvariables.
%

%
%  Determine partitioning equivalent discrete-time system and 
%  criterion matrices
%
index=nc; %lqgmat(3,ind);
gam1=gam(:,1:index);
gam2=gam(:,index+1:m);
ri1=ri(1:index,1:index);
ri2=ri(1:index,index+1:m);
ri3=ri(index+1:m,index+1:m);
am1=am(:,1:index);
am2=am(:,index+1:m);
if nti==1;
  ti1=ti(:,1:index);
  ti2=ti(:,1+index:m);
end;
%
%  Construct i1,i2 the submatrices that arrange the updating
%  of the nonupdated control variables which appear as augmented
%  state variables.
%
ind1=nc; %lqgmat(3,ind);
ind2=nc1; %lqgmat(3,ind+1);
%
%  Construct i1
%
i1=zeros(m-ind2,ind1);
for i=1:m-ind2;
  for j=1:ind1;
%    if lqgmat(3+i+ind2,ind+1)==lqgmat(3+j,ind);
    if ic1(i+ind2)==ic(j);
      i1(i,j)=1;j=ind1+1;
    end;
  end;
end;
%
%  Construct i2
%
i2=zeros(m-ind2,m-ind1);
for i=1:m-ind2;
  for j=1:m-ind1;
%    if lqgmat(3+i+ind2,ind+1)==lqgmat(3+j+ind1,ind);
    if ic1(i+ind2)==ic(j+ind1);
      i2(i,j)=1;j=m-ind1+1;
    end;
  end;
end;
%
%  Construct new equivalent discrete-time system and criterion
%  matrices based on the above patitioning and i1,i2
%
phi=[phi gam2;zeros(m-ind2,n) i2];
gam=[gam1;i1];
vi=[vi zeros(n,m-ind2);zeros(m-ind2,n+m-ind2)];
qi=[qi am2;am2' ri3];
am=[am1;ri2'];
ri=ri1;
if nti==1;
  li=[li ti2];
  ti=ti1;
  dis=[dis;zeros(m-ind2,1)];
end;
%	Construct rearranged output matrices
if no > 0
  w=w(io,io);
  c=c(io,:);
  c=[c zeros(no,m-ind1)];
  me=me(:,io);
  me=[me; zeros(m-ind2,no)];
else
  c=[]; w=c; me=c;
end
