% Matlab software associated to the paper [23]
% L.G. van Willigenburg, W.L. De Koning, 2001,
% "Synthesis of digital reduced-order compensators
% for asynchronously sampled systems",
% International Journal of System Science, 32, 7, pp. 825-835
%
% See http://www.aenf.wau.nl/mrs/staff/willigenburg/research/research.html
%
% Main M Files in ml23.tar
%
% LQGAR  : Example of the paper
% LQGADY : Function containing the LQG problem data
% LQGRARV: Function that computes equivalent discrete optimal LQG
%          regulator problem for an asynchronous aperiodically sampled linear
%          time-varying system. All matrices are specified in the
%          function func.
% DPROTVA: Deterministic Parameter Reduced Order Time Varying LQG compensation.
%          Optimal compensation of (P(i),G(i),C(i),V(i),W(i),x0m,x0c) based on
%          (Q(i),R(i),H) and nc<=nx for asynchronously sampled systems.
%          (P(i),G(i),C(i)) deterministic.
% DPROEQC: one iteration of the Deterministic Parameter
%          Reduced-Order LQG Control EQuation.
%          Control equations of compensator
%          for (P,G,C) and nc=<nx. Control Part of SDOPE
% DPROEQE: one iteration of the Deterministic Parameter
%          Reduced-Order LQG Estimator EQuation.
%          Estimation equations of compensator
%          for (P,G,C) and nc=<nx. Estimation part of SDOPE.
% GETFKL : Get or display compensator matrices f,k,l
%          for time i or all times i=1,2,..,N
%          from the compensator array xfkl
%          Time shift i=0,1,..,N -> i=1,2,..,N+1
  help readme