% ROUNDMAT: Round matrix elements close to a natural number using tol
%
%        [rmat]=roundmat(mat,tol);
%
%        mat : input matrix
%        rmat: output matrix
%        tol : tolerance > 0, default 1e-6
%
  function [mat]=roundmat(mat,tol);

  if nargin==1; tol=1e-6;
  else
    [n,m]=size(tol);
    if n~=1 | m~=1
      error('tol must be a positive scalar')
    elseif tol<=0
      error('tol must be a positive scalar')
    end
  end
  ind=abs(round(mat)-mat)<tol;
  mat=~ind.*mat+ind.*round(mat);
