% SM2ARR: Convert sampling matrix into stacked array
%         skipping the redundant elements
%
%         [sar]=sm2arr(Msamp,nu)
%
%         Input:
%            Msamp : sampling matrix
%            nu    : number of control inputs continuous time system
%
%         Output:
%            Asamp : Array with sampling scheme
%
% L.G. van Willigenburg 12-1-2004
%
function [Asamp]=sm2arr(Msamp,nu)

[n1,N]=size(Msamp); Asamp=N;

for i=1:N-1
  ny=Msamp(3+nu,i); Asamp=[Asamp; Msamp(1:3+nu+ny,i)];
end
Asamp=[Asamp; Msamp(1,N)];