function[al,uff,si,vk,co]=srict(phi,gam,qi,ri,am,li,ti,si,vk,xi,co)
% SRICT: One recursion of the Riccati type equations of an
%        LQ tracking problem with a reference for the state
%
%        [al,uff,si,vk,co]=srict(phi,gam,qi,ri,am,li,ti,si,vk,xi,co)
%
%        PHI,GAM   : equivalent discrete system matrices
%        QI,RI,AM,LI,TI  : equivalent matrices quadratic cost (including crossterm AM)
%        SI        : solution to riccati equation
%        VK        : solution to "feedforward" recursion
%        AL        : optimal feedback
%        UFF       : feedforward control component
%        CO        : cost
%
phi=phi-gam*inv(ri)*am';qi=qi-am*inv(ri)*am';li=li-ti*inv(ri)*am';
k2=inv(gam'*si*gam+ri);k1=k2*gam';al=k1*si*phi;uff=k1*vk+k2*ti';
co=co+xi-(k1*vk)'*(2*ti'+gam'*vk)-ti*k2*ti';
si=(phi-gam*al)'*si*(phi-gam*al)+al'*ri*al+qi;
vk=(phi-gam*al)'*vk-al'*ti'+li';al=al+inv(ri)*am';
